/*
 *  H8 Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	monitor.S -- H8 Monitor Core
 */

#if TARGET_CPU == 3048

#include "3048.h"

#endif	/* of #ifdef TARGET_CPU == 3048 */

#if TARGET_CPU == 3052

#include "3052.h"

#endif	/* of #ifdef TARGET_CPU == 3052 */

#if TARGET_CPU == 3068

#include "3068.h"

#endif	/* of #ifdef TARGET_CPU == 3068 */

#if TARGET_CPU == 3069

#include "3069.h"

#endif	/* of #ifdef TARGET_CPU == 3069 */

#include "comdefs.h"
#include "mondefs.h"

		.h8300h

		.text
		.align		2

/*
 *	Put Error Status
 *
 *		Input:	er3: Serial Channel #
 *			r4l: Error Status
 */

PutErrorStatus:
		push.w		r3

		mov.b		#ERROR_PROMPT, r3h
		bsr		_SendChar:16
		mov.b		r4l, r3h
		bsr		_SendByte:16
		bsr		_SendLineTerm:16

		pop.w		r3
		rts

/*
 *	Parse Command (Core)
 *
 *		Input:	er3: Serial Channel #
 */

_ParseCmdCore:
		push.l		er4
		push.l		er3

		bsr		_ReciveLine:16
		mov.l		er0, er3
		beq		ParseCmdEnd:16

		mov.l		@sp, er0			/* er0: Serial Channel # */
		mov.b		@er3+, r4h
		bne		ParseCmdCore4
								/* just return key */
		mov.b		@(_CommandMode, er0), r1l
		cmp.b		#CMDMODE_ENTER, r1l
		bne		ParseCmdCore1

		sub.l		er1, er1			/* increment address pointer */
		mov.b		@(_DataSize, er0), r1l
		shll.l		er0
		shll.l		er0
		mov.l		@(_AddressPointer, er0), er2
		add.l		er1, er2
		mov.l		er2, @(_AddressPointer, er0)
		bra		ParseCmdCore12:16
ParseCmdCore1:
		cmp.b		#CMDMODE_DUMP, r1l
		bne		ParseCmdCore12:16

		mov.l		er0, er4			/* er4: Serial Channel # */
		dec.l		#1, er3				/* roll back 1 char */
		mov.b		@(_DataSize, er0), r1l
		cmp.b		#DATA_SIZE_BYTE, r1l
		bne		ParseCmdCore2
		bsr		_DumpByteCmd:16
		bra		ParseCmdCore12:16
ParseCmdCore2:
		cmp.b		#DATA_SIZE_WORD, r1l
		bne		ParseCmdCore3
		bsr		_DumpWordCmd:16
		bra		ParseCmdCore12:16
ParseCmdCore3:
		cmp.b		#DATA_SIZE_LONG, r1l
		bne		ParseCmdCore12:16

#if 0
		bsr		DumpLongCmd
#endif	/* of #if 0 */

		bra		ParseCmdCore12:16
ParseCmdCore4:
		mov.b		@(_CommandMode, er0), r1l
		cmp.b		#CMDMODE_ENTER, r1l
		bne		ParseCmdCore6
		cmp.b		#COMMAND_END, r4h
		beq		ParseCmdCore5
		mov.l		er0, er4
		dec.l		#1, er3
		bsr		EnterWordData:16
		bra		ParseCmdCore12:16
ParseCmdCore5:
		mov.b		#CMDMODE_ADDR, r1l
		mov.b		r1l, @(_CommandMode, er0)
		bra		ParseCmdCore12:16
ParseCmdCore6:
		mov.b		@er3, r4l
		beq		ParseCmdCore7
		inc.l		#1, er3
ParseCmdCore7:
		sub.l		er1, er1
ParseCmdCore8:
		mov.w		@(_CommandString, er1), r0
		bne		ParseCmdCore9
		mov.b		#ERR_NO_COMMAND, r4l		/* error, command not found */
		bra		ParseCmdCore11
ParseCmdCore9:
		cmp.w		r0, r4
		beq		ParseCmdCore10
		inc.l		#2, er1
		bra		ParseCmdCore8
ParseCmdCore10:
		mov.l		er1, er4
		bsr		_SkipBlanks:16
		mov.l		er4, er1
		mov.l		@sp, er4
		shll.l		er1
		mov.l		@(_CommandVector, er1), er1
		jsr		@er1
		mov.l		@sp, er0
		mov.b		@(_Status, er0), r4l
		beq		ParseCmdCore12
ParseCmdCore11:
		mov.l		@sp, er3
		bsr		PutErrorStatus:16
ParseCmdCore12:
		mov.l		@sp, er3
		bsr		_SendPrompt:16
ParseCmdEnd:
		pop.l		er3
		pop.l		er4
		rts

/*
 *	Send Monitor Prompt
 *
 *		Input:	er3: Serial Channel #
 */

_MonSendPrompt:
		push.l		er4
		push.l		er3

		mov.b		@(_CommandMode, er3), r3h
		cmp.b		#CMDMODE_ENTER, r3h
		beq		MonSendPrompt1

		mov.b		r3l, r3h
		bsr		_SendHex:16
		mov.b		#MONITOR_PROMPT, r3h
		bsr		_SendChar:16
		bra		MonSendPrompt2
MonSendPrompt1:
		mov.l		@sp, er0
		shll.l		er0
		shll.l		er0
		mov.l		@(_AddressPointer, er0), er4	/* send address */
		bsr		_SendLongWord:16
		mov.b		#':', r3h
		bsr		_SendChar:16

		mov.l		@sp, er0
		shll.l		er0
		shll.l		er0
		mov.l		@(_AddressPointer, er0), er4	/* send data */
		mov.w		@er4, r4
		bsr		_SendWord:16
		mov.b		#':', r3h
		bsr		_SendChar:16
MonSendPrompt2:
		pop.l		er3
		pop.l		er4
		rts

/*
 *	Enter Word Data
 *
 *		Input:	er3: input line
 *			er4: Serial Channel #
 */

EnterWordData:
		push.l		er3
		push.l		er4

		mov.b		#0xff, r4l
		bsr		_HexASCII2Long:16
		mov.l		@sp, er4
		shll.l		er4
		shll.l		er4
		mov.l		@(_AddressPointer, er4), er1
		mov.w		r0, @er1
		inc.l		#2, er1
		mov.l		er1, @(_AddressPointer, er4)

		pop.l		er4
		pop.l		er3
		rts

/*
 *	Enter Data (Word) Command
 *
 *		Format: ew [<addr>]
 *
 *		Input:	er3: input line
 *			er4: Serial Channel #
 */

_EnterWordCmd:
		push.l		er4
		push.l		er3

		mov.b		#0xff, r4l
		bsr		_HexASCII2Long:16
		mov.l		@(4, sp), er1
		shll.l		er1
		shll.l		er1
		mov.l		@sp, er2
		cmp.l		er2, er3
		bne		EnterWordCmd1
		mov.l		@(_AddressPointer, er1), er0	/* no address specified, default address */
EnterWordCmd1:
		mov.l		er0, @(_AddressPointer, er1)
		shlr.l		er1
		shlr.l		er1
		mov.b		#CMDMODE_ENTER, r0h
		mov.b		r0h, @(_CommandMode, er1)
		mov.b		#DATA_SIZE_WORD, r0h
		mov.b		r0h, @(_DataSize, er1)

		pop.l		er3
		pop.l		er4
		rts

/*
 *	Get Address and Length
 *
 *		Input:	er3: input line
 *			er4: Serial Channel #
 *		Output: er0: Length
 *			er1: Address
 *			er3: input line
 */

GetAddrLen:
		push.l		er4

		bsr		_SkipBlanks:16
		push.l		er3
		mov.b		#0xff, r4l
		bsr		_HexASCII2Long:16	/* <Addr> */
		pop.l		er2
		cmp.l		er2, er3
		bne		GetAddrLen1

		mov.l		@sp, er0		/* er0: Serial Channel # */
		shll.l		er0
		shll.l		er0
		mov.l		@(_DumpPointer, er0), er1
		mov.l		#DEF_DUMP_LENGTH, er0	/* no address specified, default length */
		pop.l		er4
		rts
GetAddrLen1:
		push.l		er0
		bsr		_SkipBlanks:16
		push.l		er3
		mov.b		#0xff, r4l
		bsr		_HexASCII2Long:16	/* er0: <Len> */
		pop.l		er2
		cmp.l		er2, er3
		bne		GetAddrLen2

		mov.l		#DEF_DUMP_LENGTH, er0	/* no address specified, default length */
GetAddrLen2:
		pop.l		er1			/* er1: <Addr> */

		pop.l		er4
		rts

/*
 *	Dump Word Command
 *
 *		Format: dw [<addr> [<len>]]
 *
 *		Input:	er3: input line
 *			er4: Serial Channel #
 */

_DumpWordCmd:
		push.l		er5
		push.l		er4
		push.l		er3

		bsr		GetAddrLen
		mov.l		er0, er5		/* er5: <Len> */
		beq		DumpWordCmdEnd:16

		mov.l		er4, er3		/* er3: Serial Channel # */
		mov.l		er1, er4		/* er4: <Addr> */
		and.b		#0xfe, r4l
		mov.l		er3, er2
		shll.l		er2
		shll.l		er2
		add.l		er4, er0
		mov.l		er0, @(_DumpPointer, er2)
		inc.l		#1, er5
		and.b		#0xfe, r5l
		mov.w		r4, e3
		and.w		#0x000f, e3		/* e3:  leading blanks */
DumpWordCmd1:
		push.l		er4
		and.b		#0xf0, r4l
		bsr		_SendLongWord:16	/* send address */
		pop.l		er4
		shlr.w		e3
		mov.b		#5, r0l
		mulxu.b		r0l, e3
		inc.w		#1, e3
		mov.b		#' ', r3h
		bsr		_SendCharCount:16

		mov.w		#16, e3			/* e3: Counter */
		mov.w		r4, r0
		and.w		#0x000f, r0
		sub.w		r0, e3
		shlr.w		e3
DumpWordCmd2:
		mov.b		r4l, r0l
		and.b		#0x0f, r0l
		cmp.b		#0x08, r0l
		beq		DumpWordCmd3

		mov.b		#' ', r3h
		bra		DumpWordCmd4
DumpWordCmd3:
		mov.b		#'-', r3h
DumpWordCmd4:
		bsr		_SendChar:16
		push.l		er4
		mov.w		@er4, r4
		bsr		_SendWord:16
		pop.l		er4
		inc.l		#2, er4
		dec.l		#2, er5
		bne		DumpWordCmd5

		bsr		_SendLineTerm:16
		bra		DumpWordCmdEnd
DumpWordCmd5:
		dec.w		#1, e3
		bne		DumpWordCmd2

		bsr		_SendLineTerm:16
		bra		DumpWordCmd1

DumpWordCmdEnd:
		pop.l		er3
		pop.l		er4
		pop.l		er5
		mov.b		#CMDMODE_DUMP, r0l
		mov.b		r0l, @(_CommandMode, er4)
		mov.b		#DATA_SIZE_WORD, r0l
		mov.b		r0l, @(_DataSize, er4)
		rts

/*
 *	Dump byte Command
 *
 *		Format: db [<addr> [<len>]]
 *
 *		Input:	er3: input line
 *			er4: Serial Channel #
 */

_DumpByteCmd:
		push.l		er5
		push.l		er4

		bsr		GetAddrLen:16
		mov.l		er0, er5		/* er5: <Len> */
		beq		DumpByteCmdEnd

		mov.l		er4, er3		/* er3: Serial Channel # */
		mov.l		er1, er4		/* er4: <Addr> */
		mov.l		er3, er2
		shll.l		er2
		shll.l		er2
		add.l		er4, er0
		mov.l		er0, @(_DumpPointer, er2)
		bra		DumpByteCmd2
DumpByteCmd1:
		push.l		er4
		push.w		r5
		mov.w		#0x10, r5
		sub.w		r1, r5
		bsr		DumpByteLine
		pop.w		r5
		pop.l		er0
		mov.l		er4, er1
		sub.l		er0, er1
		sub.l		er1, er5
DumpByteCmd2:
		sub.l		er0, er0
		mov.b		r4l, r0l
		and.b		#0x0f, r0l
		mov.l		er0, er1
		add.l		er5, er0
		cmp.l		#0x10, er0
		bhi		DumpByteCmd1

		bsr		DumpByteLine
DumpByteCmdEnd:
		pop.l		er4
		pop.l		er5
		mov.b		#CMDMODE_DUMP, r0l
		mov.b		r0l, @(_CommandMode, er4)
		mov.b		#DATA_SIZE_BYTE, r0l
		mov.b		r0l, @(_DataSize, er4)
		rts

/*
 *	Dump Byte Line
 *
 *		Input:	r3l: Serial Channel #
 *			er4: Address
 *			r5 : Length
 *		Output:	er4: Next Address
 *			r5 : always 0
 */

DumpByteLine:
		push.l		er3

		mov.w		r4, e3
		and.w		#0x000f, e3		/* e3:  leading blanks */
DumpByteLine1:
		push.w		r5
		push.l		er4
		and.b		#0xf0, r4l
		bsr		_SendLongWord:16	/* send address */
		mov.l		@sp, er4
		mov.b		#3, r0l
		mulxu.b		r0l, e3
		inc.w		#1, e3
		mov.b		#' ', r3h
		bsr		_SendCharCount:16
DumpByteLine2:
		and.b		#0x0f, r0l
		cmp.b		#0x07, r0l
		beq		DumpByteLine3

		mov.b		#' ', r3h
		bra		DumpByteLine4
DumpByteLine3:
		mov.b		#'-', r3h
DumpByteLine4:
		bsr		_SendChar:16
		mov.b		@er4, r3h
		bsr		_SendByte:16
		mov.b		r4l, r0l
		inc.l		#1, er4
		dec.w		#1, r5
		bne		DumpByteLine2

		pop.l		er4
		pop.w		r5
		mov.w		r5, r0
		mov.w		r4, r1
		and.w		#0x000f, r1
		add.w		r1, r0
		mov.w		#0x10, e3
		sub.w		r0, e3
		and.w		#0x000f, r0
		mov.b		#3, r0l
		mulxu.b		r0l, e3
		mov.w		r4, r0
		and.w		#0x000f, r0
		add.w		r0, e3
		inc.w		#2, e3
		mov.b		#' ', r3h
		bsr		_SendCharCount:16
DumpByteLine5:
		mov.b		@er4, r3h
		cmp.b		#0x20, r3h
		blo		DumpByteLine6
		cmp.b		#0x7f, r3h
		blo		DumpByteLine7
DumpByteLine6:
		mov.b		#'.', r3h
DumpByteLine7:
		bsr		_SendChar:16
		inc.l		#1, er4
		dec.w		#1, r5
		bne		DumpByteLine5

		bsr		_SendLineTerm:16

		pop.l		er3
		rts

/*
 *	Fill byte Command
 *
 *		Format: fb [<addr> [<len> [<init> [<inc> [<repeat>]]]]]
 *
 *		Input:	er3: input line
 *			er4: Serial Channel #
 */

_FillByteCmd:
		push.l		er4
		push.l		er3

		bsr		GetAddrLen:16
		push.l		er1			/* sp+ 4: <addr> */
		push.l		er0			/* sp+ 0: <len>  */

		bsr		_SkipBlanks:16
		push.l		er3
		mov.b		#0xff, r4l
		bsr		_HexASCII2Long:16	/* er0  : <init> */
		pop.l		er1
		cmp.l		er1, er3
		bne		FillByteCmd1
		sub.l		er0, er0

FillByteCmd1:
		push.l		er0			/* sp+ 8: <addr> */
							/* sp+ 4: <len>  */
							/* sp+ 0: <init> */

		bsr		_SkipBlanks:16
		push.l		er3
		mov.b		#0xff, r4l
		bsr		_HexASCII2Long:16	/* er0  : <inc>  */
		pop.l		er1
		cmp.l		er1, er3
		bne		FillByteCmd2
		sub.l		er0, er0

FillByteCmd2:
		push.l		er0			/* sp+12: <addr> */
							/* sp+ 8: <len>  */
							/* sp+ 4: <init> */
							/* sp+ 0: <inc>  */

		bsr		_SkipBlanks:16
		push.l		er3
		mov.b		#0xff, r4l
		bsr		_HexASCII2Long:16	/* er0  : <repeat> */
		pop.l		er1
		cmp.l		er1, er3
		bne		FillByteCmd3
		sub.l		er0, er0
		mov.b		#1, r0l

FillByteCmd3:
		pop.l		er1			/* er1  : <inc>    */
							/* sp+12: <addr>   */
							/* sp+ 8: <len>    */
							/* sp+ 4: <init>   */
		push.l		er0			/* sp+ 0: <repeat> */
FillByteCmd4:
							/* er1  : <inc>    */
		mov.l		@( 4, sp), er0		/* er0  : <init>   */
		mov.l		@( 8, sp), er2		/* er2  : <len>    */
		mov.l		@(12, sp), er3		/* er3  : <addr>   */
FillByteCmd5:
		mov.b		r0l, @er3
		add.l		er1, er0
		inc.l		#1, er3
		dec.l		#1, er2
		bne		FillByteCmd5

		mov.l		@sp, er0		/* er0  : <repeat> */
		dec.l		#1, er0
		mov.l		er0, @sp
		bne		FillByteCmd4

		pop.l		er0
		pop.l		er0
		pop.l		er0
		pop.l		er0

		pop.l		er3
		pop.l		er4
		rts

		.end
